unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  TADrawUtils, TAGraph,  OSPrinters, PrintersDlgs, TAPrint, Printers,
  TADrawerSVG, TADrawerCanvas;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonSVG: TButton;
    ButtonPrint: TButton;
    Chart1: TChart;
    Panel1: TPanel;
    PrintDialog1: TPrintDialog;
    SaveDialog1: TSaveDialog;
    procedure ButtonSVGClick(Sender: TObject);
    procedure ButtonPrintClick(Sender: TObject);
    procedure Chart1AfterCustomDrawBackWall(ASender: TChart;
      ADrawer: IChartDrawer; const ARect: TRect);
  private
    function GetFileName(const AExt: String): String;

  public

  end;

var
  Form1: TForm1;

implementation


{$R *.lfm}

{ TForm1 }

procedure TForm1.Chart1AfterCustomDrawBackWall(ASender: TChart;
  ADrawer: IChartDrawer; const ARect: TRect);
var
  Xmin,Xmax,Ymin,Ymax : integer;
  Lx, Ly : integer;

begin
  // Nur als Beispielscode:

  ADrawer.Pen.Width := 2;  {-> Ergibt eine Fehlermeldung}

  // Zuweisen von bereit von Chartwerten auf Pixel umgerechneten Werte:
  Xmin := 50;
  Ymin := 50;
  Xmax := 250;
  Ymax := 150;
  Lx   := (Xmax - Xmin) div 2;
  Ly   := (Ymax - Ymin) div 2;

  ADrawer.Rectangle(Xmin,Ymin,Xmax,Ymax);
  ADrawer.Ellipse(Xmin,Ymin,Xmax,Ymax);
  ADrawer.Line(Xmin + Lx,Ymin,Xmin + Lx,Ymax);
  ADrawer.Line(Xmin,Ymin + Ly,Xmax ,Ymin + Ly);
end;

procedure TForm1.ButtonSVGClick(Sender: TObject);
begin
  Chart1.SaveToSVGFile(GetFilename('svg'));
end;

procedure TForm1.ButtonPrintClick(Sender: TObject);
const
  MARGIN = 10;
var
  r: TRect;
  d: Integer;
begin
  if not PrintDialog1.Execute then exit;
  Printer.BeginDoc;
  try
    r := Rect(0, 0, Printer.PageWidth, Printer.PageHeight div 2);
    d := r.Right - r.Left;
    r.Left += d div MARGIN;
    r.Right -= d div MARGIN;
    d := r.Bottom - r.Top;
    r.Top += d div MARGIN;
    r.Bottom -= d div MARGIN;
    Chart1.Draw(TPrinterDrawer.Create(Printer,False), r);
  finally
    Printer.EndDoc;
  end;

end;

function TForm1.GetFileName(const AExt: String): String;
begin
  with SaveDialog1 do begin
    FileName := '';
    DefaultExt := AExt;
    if not Execute then Abort;
    Result := FileName;
  end;
end;

end.

